Bug 823499 - fvwm crashes on clicking on browser back button
fvwm crashes on clicking on browser back button
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: fvwm (Show other bugs)
23
i686 Linux
unspecified Severity high
: ---
: ---
Assigned To: Peter Lemenkov
Fedora Extras Quality Assurance
: Reopened
: 823518 967548 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-05-21 07:53 EDT by nvwarr
Modified: 2016-03-13 19:54 EDT (History)
7 users (show)

See Also:
Fixed In Version: fvwm-2.6.5-12.fc23
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-03-13 19:54:19 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Patch which seems to fix the problem (445 bytes, patch)
2012-05-21 07:53 EDT, nvwarr
no flags Details | Diff

  None (edit)
Description nvwarr 2012-05-21 07:53:01 EDT
Created attachment 585791 [details]
Patch which seems to fix the problem

Description of problem:

In either chrome or firefox, clicking on the "back" button sometimes crashes fvwm.

Version-Release number of selected component (if applicable):

fvwm-2.6.5-1.fc16.i686
(also in 2.6.4 when built from source)

How reproducible:

Typically happens after ten minutes or so of surfing the web.

Steps to Reproduce:
1. surf the web (chrome or firefox and probably others)
2. use the "back" button
  
Actual results:

most of the time it works, but sometimes the whole window manager crashes and dumps you back to the gdm login

Expected results:

fvwm should not crash!

Additional info:

#0  0x28561c54 in free () from /lib/libc.so.7
#1  0x281b745c in XFreeStringList () from /usr/local/lib/libX11.so.6
#2  0x080ee215 in FlocaleFreeNameProperty (ptext=0x289b3008) at Flocale.c:2358
#3  0x08095e42 in free_window_names (fw=0x289b3000, nukename=0, nukeicon=1) at add_window.c:3171
#4  0x080e664f in EWMH_WMIconName (fw=0x289b3000, ev=0x812d000, style=0x0,  any=0) at ewmh_names.c:175
#5  0x080c8ce5 in EWMH_ProcessPropertyNotify (exc=0x28903180) at ewmh_events.c:1620
#6  0x0807c773 in HandlePropertyNotify (ea=0xbfbfe474) at events.c:3628
#7  0x0807d426 in dispatch_event (e=0xbfbfe498) at events.c:4135
#8  0x0807d52b in HandleEvents () at events.c:4179
#9  0x080a2898 in main (argc=2, argv=0xbfbfe7ac) at fvwm.c:2591

Problem does not occur with 2.5.30 (Fedora rpm) and does not seem to occur with 2.6.3 (built from sources) but does occur with 2.6.4 and 2.6.5.

Between 2.6.3 and 2.6.4 there was a change to fvwm/events.c:3386:
               if (!WAS_ICON_NAME_PROVIDED(fw))
became:
               if (!WAS_ICON_NAME_PROVIDED(fw) || (fw->icon_name.name &&
                       (fw->icon_name.name != fw->name.name)))

Backing out this change seems to fix the problem (see attached patch). I note that 2.7.0 reverts to the 2.6.3 without the OR condition, so I suspect someone has already noticed this bug, which, as far as I can tell, is only present in 2.6.4 and 2.6.5.
Comment 1 nvwarr 2012-05-22 01:42:19 EDT
*** Bug 823518 has been marked as a duplicate of this bug. ***
Comment 2 Thomas Adam 2012-06-03 10:10:25 EDT
(In reply to comment #0)
> #0  0x28561c54 in free () from /lib/libc.so.7
> #1  0x281b745c in XFreeStringList () from /usr/local/lib/libX11.so.6
> #2  0x080ee215 in FlocaleFreeNameProperty (ptext=0x289b3008) at
> Flocale.c:2358
> #3  0x08095e42 in free_window_names (fw=0x289b3000, nukename=0, nukeicon=1)
> at add_window.c:3171

Can you send through your fvwm2rc file, please?

> Problem does not occur with 2.5.30 (Fedora rpm) and does not seem to occur

That version is unsupported.

> with 2.6.3 (built from sources) but does occur with 2.6.4 and 2.6.5.
> 
> Between 2.6.3 and 2.6.4 there was a change to fvwm/events.c:3386:
>                if (!WAS_ICON_NAME_PROVIDED(fw))
> became:
>                if (!WAS_ICON_NAME_PROVIDED(fw) || (fw->icon_name.name &&
>                        (fw->icon_name.name != fw->name.name)))

That's because I made this change for 2.6.3.

> Backing out this change seems to fix the problem (see attached patch). I
> note that 2.7.0 reverts to the 2.6.3 without the OR condition, so I suspect
> someone has already noticed this bug, which, as far as I can tell, is only
> present in 2.6.4 and 2.6.5.

No -- backing out this change is not a solution.  Note that I cannot reproduce your problem at all, so I'm interested in knowing about your fvwm2rc file.  Can you also tell me whether this is 64bit?

Why are you looking at 2.7.0?  That version of FVWM is not supported, never has been, and was deprecated by me (and even announced as such) months ago.  This means your assertion above is completely incorrect.  Please don't mislead people in thinking anything else.

See:  http://www.mail-archive.com/fvwm-workers@fvwm.org/msg02572.html
Comment 3 Jos de Kloe 2012-11-13 09:47:53 EST
Today I have been bitten by a similar problem, that may have the same cause. I upgraded to the latest available Fedora 16 packages. Strange enough nothing changed for fvwm which remained at fvwm 2.6.5-1.fc16

Following this update I found that in certain conditions the whole window manager crashes and dumps you back to the gdm login. This especially occurs in thunderbird while changing from one tab to another, and also sometimes in firefox. This for example made it impossible to start and use the lightning plugin.

After finding the information in this bug report I tried to manually compile fvwm version 2.6.3 in my user account (I have no root permission at my machine at work).
Switching to this fvwm version seemed impossible at first, untill I found the package xorg-x11-xinit-session needs to be installed first. Our system administrator was kind enough to quickly do this for me, and switching to version 2.6.3 clearly solved the problem for me.

If you need any additional info please let me know.
Comment 4 Jos de Kloe 2012-11-13 11:13:17 EST
I forgot to mention that I see this line in my .xsession-errors file after the crash has happened:

fvwm: xcb_io.c:128: append_pending_request: Assertion `(((long) (dpy->xcb->pendi
ng_requests_tail->sequence) - (long) (node->sequence)) < 0)' failed.
Abort (core dumped)
Comment 5 Fedora End Of Life 2013-01-16 18:26:34 EST
This message is a reminder that Fedora 16 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 16. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '16'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 16's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 16 is end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" and open it against that version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 6 Fedora End Of Life 2013-02-13 20:50:29 EST
Fedora 16 changed to end-of-life (EOL) status on 2013-02-12. Fedora 16 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 7 Jos de Kloe 2013-05-31 06:26:21 EDT
problem is still present in Fedora18. See bug #967548. I'll attach my config file there so you can inspect it.
Comment 8 Peter Lemenkov 2013-10-10 04:14:35 EDT
*** Bug 967548 has been marked as a duplicate of this bug. ***
Comment 9 Anonymous bin Ich 2014-03-11 14:31:21 EDT
I suppose this bug is in fvwm itself. See here: https://bugs.launchpad.net/ubuntu/+source/fvwm/+bug/1225839

I have been using cvs version of fvwm for a week now (self-compiled) and the problem hasn't repeated itself. I am not good with cvs so couldn't find the exact date when it was fixed.
Comment 10 nvwarr 2014-03-13 08:20:52 EDT
Yes, it seems dje has essentially done the same thing I did, back in Movember:) He change the lines

               if (!WAS_ICON_NAME_PROVIDED(fw) || (fw->icon_name.name &&
                       (fw->icon_name.name != fw->name.name)))

to be

                if (!WAS_ICON_NAME_PROVIDED(fw)
#if 0
                    /* dje, reported as causing various dumps.
                       I tried to debug, but so far haven't even figured out
                       how to exercise this logic. Mov 9, 2013. */
                    || (fw->icon_name.name &&
                        (fw->icon_name.name != fw->name.name))
#endif
)

I've been using fvwm continuously with the bit after the "||" removed, for nearly two years now, reapplying the patch after each upgrade of Fedora (I'm on Fedora 20 now), and it works fine. After each upgrade, I've tried the unpatched version until it crashed. That typically took less than an hour. Then I switched to the patched version and have had no problems with it.
Comment 11 Jan Kurik 2015-07-15 11:08:44 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 23 development cycle.
Changing version to '23'.

(As we did not run this process for some time, it could affect also pre-Fedora 23 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 23 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora23
Comment 12 nvwarr 2016-01-18 07:33:37 EST
The problem still occurs with the Fedora 23 version. Another way to trigger it, which seems to be quite reproducible is to open an image in gimp and then close gimp.

After applying dje's changes (see previous comment) I have been unable to trigger it.

This bug is rapidly approaching its fourth birthday, yet it is still marked as "new"!
Comment 13 Fedora Update System 2016-03-03 15:06:01 EST
fvwm-2.6.5-12.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-0e095aba1f
Comment 14 Peter Lemenkov 2016-03-03 15:06:27 EST
Sorry for the delay - I'm no longer using fvwm actively. Please try this build.
Comment 15 Fedora Update System 2016-03-04 21:22:52 EST
fvwm-2.6.5-12.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-0e095aba1f
Comment 16 nvwarr 2016-03-07 02:41:37 EST
This looks good. I installed fvwm-2.6.5-12.fc23.x86_64 on Friday and so far no crashes.
Comment 17 Fedora Update System 2016-03-13 19:54:16 EDT
fvwm-2.6.5-12.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.